#-----------------------------------------------------------------------------
%global		dist	.ok
#-----------------------------------------------------------------------------
Name		:	ucsd-psystem-xc
Version		:	0.50.3
Release		:	17.2.0.rel%{?dist}
Summary		:	UCSD p-System cross compiler

Packager	:	Osukiss Project <build-ok@osukiss.org>

License		:	GPLv2+
URL		:	https://github.com/jmrcpn/ucsd-psystem-vm/

Source0		:	%{name}-%{version}.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	bison
BuildRequires	:	boost-devel
BuildRequires	:	libexplain-devel
BuildRequires	:	libpng-devel
BuildRequires	:	meson
BuildRequires	:	sharutils

#-----------------------------------------------------------------------------
%description
The ucsd-psystem-xc package is a collection
of tools for compiling Pascal source files to
produce UCSD p_System code files.  

The package includes:

ucsdpsys(1)
       A laucher to run the virtual machine comfortably from the
       command line.  It includes a batch mode for automating
       (scripting) operations.

ucsdpsys_assemble(1)
       The cross assembler.  It is able to assemble several different
       target microprocessor architectures in the one executable.

ucsdpsys_compile(1)
       The cross compiler.  It understands the UCSD Pascal dialect,
       including UNIT definitions and references.

ucsdpsys_depends(1)
       May be used to determine include file dependencies, for use
       with make(1) and other build tools.

ucsdpsys_disassemble(1)
       For disassembling UCSD p-System code files.  This is used to
       verify the correctness of the compiler.

ucsdpsys_downcase(1)
       A untility for converting Pascal code to lower case, leaving
       string constants and comments unaltered.

ucsdpsys_errors(1)
       A utility to translate back and forth between text and binary
       representations of the assembler error message files.

ucsdpsys_libmap(1)
       A utility for printing segment maps of UCSD p-System library
       files.

ucsdpsys_librarian(1)
       A utility for manipulating the segments within UCSD p-System
       codefiles.

ucsdpsys_link(1)
       A utility for linking UCSD p-System codefiles to their
       assembler components.

ucsdpsys_opcodes(1)
       A utility to translate back and forth between text and binary
       representations of the assembler opcode files.

ucsdpsys_setup(1)
       A utility to translate back and forth between text and binary
       representations of the system.miscinfo file.

#-----------------------------------------------------------------------------
%files
%defattr(-, root,root, -)
%{_bindir}/ucsdpsys
%{_bindir}/ucsdpsys_assemble
%{_bindir}/ucsdpsys_charset
%{_bindir}/ucsdpsys_compile
%{_bindir}/ucsdpsys_depends
%{_bindir}/ucsdpsys_disassemble
%{_bindir}/ucsdpsys_downcase
%{_bindir}/ucsdpsys_errors
%{_bindir}/ucsdpsys_foto
%{_bindir}/ucsdpsys_libmap
%{_bindir}/ucsdpsys_librarian
%{_bindir}/ucsdpsys_link
%{_bindir}/ucsdpsys_littoral
%{_bindir}/ucsdpsys_opcodes
%{_bindir}/ucsdpsys_osmakgen
%{_bindir}/ucsdpsys_pretty
%{_bindir}/ucsdpsys_setup
%{_mandir}/man1/ucsdpsys.1.gz
%{_mandir}/man1/ucsdpsys_assemble.1.gz
%{_mandir}/man1/ucsdpsys_charset.1.gz
%{_mandir}/man1/ucsdpsys_compile.1.gz
%{_mandir}/man1/ucsdpsys_depends.1.gz
%{_mandir}/man1/ucsdpsys_disassemble.1.gz
%{_mandir}/man1/ucsdpsys_downcase.1.gz
%{_mandir}/man1/ucsdpsys_errors.1.gz
%{_mandir}/man1/ucsdpsys_foto.1.gz
%{_mandir}/man1/ucsdpsys_history.1.gz
%{_mandir}/man1/ucsdpsys_libmap.1.gz
%{_mandir}/man1/ucsdpsys_librarian.1.gz
%{_mandir}/man1/ucsdpsys_link.1.gz
%{_mandir}/man1/ucsdpsys_littoral.1.gz
%{_mandir}/man1/ucsdpsys_opcodes.1.gz
%{_mandir}/man1/ucsdpsys_osmakgen.1.gz
%{_mandir}/man1/ucsdpsys_pretty.1.gz
%{_mandir}/man1/ucsdpsys_setup.1.gz
%{_mandir}/man1/ucsdpsys_xc_license.1.gz
%{_mandir}/man5/ucsdpsys_codefile.5.gz
%{_mandir}/man5/ucsdpsys_errors.5.gz
%{_mandir}/man5/ucsdpsys_opcodes.5.gz



#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

meson	setup						\
	--prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
        --bindir=%{_bindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--datadir=%{_datadir}				\
	_bld

meson	compile						\
	-C _bld						\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check
meson	test						\
		-C _bld					\

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

meson	install						\
		-C _bld					\
		--destdir=%{buildroot}			\

#-----------------------------------------------------------------------------
%changelog
